Unit zp40e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, ZP30E_p;

procedure zp40e(NP :Integer; var A :Array of Extended;
                var B :Array of Extended; U :Extended; V :Extended;
                var RAB :Array of Extended);

implementation

procedure zp40e(NP :Integer; var A :Array of Extended;
                var B :Array of Extended; U :Extended; V :Extended;
                var RAB :Array of Extended);
var
N,N1,I,K,J :Integer;
S,Q,R,T1,T2 :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8;
begin
R := 1.e0/U;
S := -R*V;
N := NP;
N1 := N+1;
if ( S ) < 0
 then goto _3
 else if ( S ) > 0
       then goto _3
       else goto _1;
_1:
Q := 1.e0;
for I:=1 to N1 do
 begin
  B[I-1] := Q*A[I-1];
_2:
  Q := Q*R;
 end;
goto _8;
_3:
for I:=1 to N1 do
 begin
_4:
  RAB[I-1] := A[I-1];
 end;
K := N;
T1 := 1.e0;
T2 := 1.e0;
for I:=1 to N1 do
 begin
  B[I-1] := ZP30E(K,RAB,S)*T2;
  if ( K ) < 0
   then goto _8
   else if ( K ) > 0
         then goto _5
         else goto _8;
_5:
  T2 := T2*R;
  Q := 1.e0;
  for J:=1 to K do
   begin
    RAB[J-1] := RAB[J+0]*Q/T1;
_6:
    Q := Q+1.e0;
   end;
  T1 := T1+1.e0;
_7:
  K := K-1;
 end;
_8:
end;

end.
